<?php 
	/** Relata Configuration
		Version: 	1.0
		Revision: 	3
		Updated: 	December 14, 2005
		Updated By:	Avinesh Bangar (avinesh@stratabase.com)
	**/

	// Step 1.
	// The URL from which Relata will be accessible -- requires trailing forward-slash
	$web_dir = "http://www.yourhost.com/relata/";

	// Set to your SMTP server -- for Windows, set to your ISP's SMTP server (eg. "mail.host.com")
	$smtphost = "localhost";
	
	// Step 2.
	// The database name
	$db_name = "relata";
	// The server on which the database resides
	$db_host = "localhost";
	// The username for the Relata database
	$db_username = "relata";
	// The password for the Relata database
	$db_password = "password";

	// Step 3.
	// Enable or disable support module
	$support_module = "on";
	// Change this to the name of your support department or leave as-is.
	$relata_support = "Relata Support";
	// Change this to the e-mail or contact number of your support department or leave as-is.
	// Backup login instructions for new users will also be e-mailed here (eg. user doesn't get login instructions).
	$relata_contact = "support@relata.com";
	$admin_contact = "user@host.com";

	// Step 4.
	// Enable / disable certain Relata modules
	// Your Relata license ultimately determines which Relata modules are enabled/disabled

	// ** Relata Lite (Contact Manager, Activity Manager, Group Email, Notes)
	$contact_module 	= "on";
	$activity_module 	= "on";
	$groupemail_module 	= "on";
	$notes_module 		= "on";
	
	// ** Relata Pro (includes all of the above plus the following modules -- Account Manager, Outcomes/Focus Areas, Logs)
	$account_module 	= "on";
	$outcomes_module 	= "on";
	$logs_module 		= "on";

	// ** Relata Enterprise (includes all of the above plus the following modules -- Knowledge Management and File Manager)
	$km_module 			= "on";
	$fm_module 			= "on";
	// The directory where user uploads will be sent to (file manager module)
	$upload_dir = "/var/www/html/relata/upload/";
	// Ensure the following is set in your php.ini file
	// file_uploads = On
	// upload_max_filesize= 10M
	// post_max_size = 100M

	// Step 5.
	// Global modules (not governed by license)
	// * Setting Resync module to off does not prevent data synchronization
	$resync_module 		= "on";
	$msgs_module 		= "on";
	$stats_module		= "on";
	$backup_module		= "on";
	
	// ** DO NOT EDIT ANYTHING BELOW THIS LINE **
	// MySQL database session management (required)
	include("db_session.php");
?>
