<?php 
	include("instglobal.php");
	$_SESSION['continue'] = true;
	$_SESSION['thread_safe'] = false;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!--
Avinesh Bangar (avinesh@stratabase.com)
Copyright 2005 Stratabase.
Filename: installhelper.php
Last Updated: December 8, 2005
-->
<html>
<head>
	<title>Relata Installation Helper</title>
</head>

<STYLE TYPE="text/css" MEDIA=screen>
<!--
DIV { text-align:left;font-family:arial;font-size:12px;font-weight:bold; }
TD { text-align:left;font-family:arial;font-size:12px; }
-->
</STYLE>

<body>
<div>
Relata Installation Helper v1.0 - Page 1
<p></p>
<table border="0" cellspacing="5" cellpadding="0">
<tr>
	<td>Operating System:</td>
	<td>
	<?php 
	$os_name = substr(php_uname(),0,strpos(php_uname(),' '));
	$os_code = strtolower(substr($os_name,0,3));
	$_SESSION['os'] = $os_code;
	echo $os_name;
	?>
	</td>
</tr>
<tr>
	<td>Path to php.ini:</td>
	<td>
	<?php 
		ob_start();
		phpinfo(INFO_GENERAL);
		$gen_info = ob_get_contents();
		ob_end_clean();

  		foreach (split("\n",$gen_info) as $line) 
		{
    		if (eregi('command',$line)) 
		    	continue;

		    if (preg_match('/Thread Safety.*(enabled|yes)/Ui',$line))
		    	$_SESSION['thread_safe'] = true;
		}
		
		$tmpstr = trim(substr(stristr($gen_info,'<td class="e">Configuration File (php.ini) Path </td>'),67,255));
		$_SESSION['phppath'] = (strlen(substr($tmpstr, 0, strpos($tmpstr, "<"))) > 6) ? substr($tmpstr, 0, strpos($tmpstr, "<")) : '<font color="red">Not set</font>';
		echo $_SESSION['phppath'];
	?>
	</td>
</tr>
<tr>
	<td>PHP Version:</td>
	<td>
	<?php 
		$_SESSION['major_ver'] = substr(phpversion(),0,3);
		if (phpversion() > 4.1)
			echo "<font color=\"green\">".phpversion()." (Major Version: ".$_SESSION['major_ver'].")</font>";
		if (phpversion() < 4.1)
		{
			echo "<font color=\"red\">".phpversion()." -- PHP version not supported. Please upgrade to PHP 4.1 or better.</font>";
			$_SESSION['continue'] = false;
		}
	?>
	</td>
</tr>
<tr>
	<td>PHP Safe Mode:</td>
	<td>
	<?php 
		if (!get_cfg_var('safe_mode'))
			echo "<font color=\"green\">Off</font>";
		else
			echo "<font color=\"green\">On</font> -- Should be set to Off for optimal performance.";
	?>
	</td>
</tr>
<tr><td>&nbsp;</td></tr>
<tr>
	<td>PHP Session Support:</td>
	<td>
	<?php 
	ob_start();
	phpinfo(INFO_MODULES);
	$_SESSION['modules'] = ob_get_contents();
	ob_end_clean();
	if (stristr($_SESSION['modules'],'<td class="e">Session Support </td><td class="v">enabled </td>'))
		echo "<font color=\"green\">Enabled</font>";
	else
	{
 		echo "<font color=\"red\">Disabled<font> -- PHP session support must be enabled.";
		$_SESSION['continue'] = false;
	}
	?>
	</td>
</tr>
<tr>
	<td>PHP MySQL Support:</td>
	<td>
	<?php 
	if (stristr($_SESSION['modules'],'<th>MySQL Support</th><th>enabled</th>'))
 		echo "<font color=\"green\">Enabled</font>";
	else
	{
		echo "<font color=\"red\">Disabled</font> -- Native MySQL support not detected.";
		$_SESSION['continue'] = false;
	}
	?>
	</td>
</tr>
<tr>
	<td>PHP Register Globals:</td>
	<td>
	<?php 
	if (get_cfg_var('register_globals') == "1")
		echo "<font color=\"green\">On</font> -- Possible security risk (should be set to Off).";
	else
		echo "<font color=\"green\">Off</font>";
	?>
	</td>
</tr>
<tr>
	<td>PHP SMTP Host:</td>
	<td>
	<?php 
	if (get_cfg_var('SMTP') == "localhost" && $_SESSION['os'] != "win")
		echo "<font color=\"green\">".get_cfg_var('SMTP')."</font>. Ensure mail server is running.";
	else if ((get_cfg_var('SMTP') == "localhost" || !get_cfg_var('SMTP')) && $_SESSION['os'] == "win")
	{
		echo "<font color=\"red\">".get_cfg_var('SMTP')."</font>. SMTP host should be set to your ISP's SMTP server.";
		$_SESSION['continue'] = false;
	}
	else 
		echo "<font color=\"green\">".get_cfg_var('SMTP')."</font>";
	?>
	</td>
</tr>
<?php 
 if ($_SESSION['os'] != "win")
 {
?>
<tr>
	<td>Path to sendmail:</td>
	<td>
	<?php 
	if (stristr($_SESSION['modules'],'<tr><td class="e">Path to sendmail </td>'))
	{
		$tmp = substr(stristr($_SESSION['modules'],'<tr><td class="e">Path to sendmail </td><td class="v">/usr/sbin/sendmail -t -i  </td></tr>'),54,100);
		$pos = strpos($tmp, "<");
		if (strlen(substr($tmp, 0, $pos-1)) > 8)
			echo "<font color=\"green\">".substr($tmp, 0, $pos-1)."</font>";
	}
	else
	{
		echo "<font color=\"red\">Path not set</font>. Set path to sendmail or sendmail wrapper.";
		$_SESSION['continue'] = false;
	}
	?>
	</td>
</tr>
<?php 
 }
?>
<tr>
	<td>PHP Extensions Directory:</td>
	<td>
	<?php 
	if (get_cfg_var('extension_dir'))
		echo "<font color=\"green\">".str_replace("\\","/",get_cfg_var('extension_dir'))."</font>";
	else
	{
		echo "<font color=\"red\">Extensions directory not set.</font>";
		$_SESSION['continue'] = false;
	}
	?>
	</td>
</tr>
<tr>
	<td>ionCube Loader:</td>
	<td>
	<?php 
	if (extension_loaded('ionCube Loader'))
		echo "<font color=\"green\">Installed</font>";
	else
	{
		
		$ts = ((($os_code != 'win') && $_SESSION['thread_safe']) ? '_ts' : '');
		
		$install_str = ($_SESSION['os'] == "win") ? "ioncube_loader_".$_SESSION['os']."_".$_SESSION['major_ver'].".dll" : "ioncube_loader_".$_SESSION['os']."_".$_SESSION['major_ver']."".$ts.".so";
		if ($_SESSION['os'] == "win" || get_cfg_var('safe_mode'))
		{
			echo "<font color=\"red\">".$install_str." must be copied to PHP extensions directory for Windows and safe-mode PHP.</font>";
			$_SESSION['continue'] = false;
		}
		else
		{
			if (get_cfg_var('enable_dl'))
			{
				$ok = false;
				
				// some code portions below from ioncube-loader-helper.php
				// an absolute path does not work with dl(), it must be relative
				$_ln_new=$install_str;
				$_ln_new_loc="/ioncube/$_ln_new";

				$_extdir = ini_get('extension_dir');
				if ($_extdir == './') 
				  $_extdir = '.';

				$_oid = $_id = realpath($_extdir);

				$_here = dirname(__FILE__);
				if ((@$_id[1]) == ':') 
				{
		  			$_id = str_replace('\\','/',substr($_id,2));
				  	$_here = str_replace('\\','/',substr($_here,2));
				}
				$_rd=str_repeat('/..',substr_count($_id,'/')).$_here.'/';
				
				$ok = ($_oid !== false) ? true : false;

				if ($ok)
				{
		  			$_ln = '';
				    $_i=strlen($_rd);
		  			
					while($_i--)
					{
						if($_rd[$_i]=='/')
						{
						  $_lp=substr($_rd,0,$_i).$_ln_new_loc;
						  $_fqlp=$_oid.$_lp;
						  if(@file_exists($_fqlp))
						  {
							$_ln=$_lp;
							break;
		  				  }
						}
				    }
					
			 		 if (!$_ln) 
					 {
						if (@file_exists($_id.$_ln_new_loc)) 
						{
						  $_ln = $_ln_new_loc;
						}
					 }
					 
			  		if ($_ln) 
					{
						// dynamically load ionCube Loader
						dl($_ln);
						if (extension_loaded('ionCube Loader'))
						{
							echo "<font color=\"green\">Installed -- Dynamically Loaded</font>";
						}
						else
						{
							echo "<font color=\"red\">Not Installed.</font> Ensure that 'ioncube' folder exists and that it contains '".$install_str."'</font>";
							$_SESSION['continue'] = false;
						}
					}
				}
			}
			else
			{
				echo "<font color=\"red\">PHP dynamic loading is disabled. ".$install_str." must be copied to PHP extensions directory and loaded in php.ini.</font>";
				$_SESSION['continue'] = false;
			}
		}
	}
	?>
	</td>
</tr>
<tr>
	<td>Relata License Present:</td>
	<td>
	<?php 
	if (file_exists('../relatalicense.php'))
		echo "<font color=\"green\">Yes</font>";
	else
	{
		echo "<font color=\"red\">Relata license not found.</font>&nbsp;<a href=\"datablock.php\" target=\"_blank\">Click here</a> to request one.";
		$_SESSION['continue'] = false;
	}

	clearstatcache();
	?>
	</td>
</tr>
<tr><td>&nbsp;</td></tr>
<tr>
	<td>PHP File Uploads:</td>
	<td>
	<?php 
	if (get_cfg_var('file_uploads') > 0)
		echo "<font color=\"green\">On</font> (Required for Relata File Manager)";
	else
		echo "<font color=\"red\">Off</font> (Should be set to 'On' if using Relata File Manager)";
	?>
	</td>
</tr>
<tr>
	<td>PHP Upload Max Filesize:</td>
	<td>
	<?php 
	if (get_cfg_var('upload_max_filesize') >= 10)
		echo "<font color=\"green\">".get_cfg_var('upload_max_filesize')."</font> (Required for Relata File Manager)";
	else
		echo "<font color=\"red\">".get_cfg_var('upload_max_filesize')."</font> (Should be set to 10M or more, if using Relata File Manager)";
	?>
	</td>
</tr>
<tr>
	<td>PHP Post Max Size:</td>
	<td>
	<?php 
	if (get_cfg_var('post_max_size') >= 20)
		echo "<font color=\"green\">".get_cfg_var('post_max_size')."</font> (Required for Relata File Manager)";
	else
		echo "<font color=\"red\">".get_cfg_var('post_max_size')."</font> (Should be set to 20M or more, if using Relata File Manager)";
	?>
	</td>
</tr>
<tr><td>&nbsp;</td></tr> 
<tr>
	<td>config.inc.php Writable:</td>
	<td>
	<?php 
	if (file_exists('../config.inc.php'))
	{
		if (is_writable('../config.inc.php'))
			echo "<font color=\"green\">Yes</font>";
		else
		{
			echo "<font color=\"red\">No</font> -- Check web permissions. Current permissions: ".substr(sprintf('%o', fileperms('config.inc.php')), -4);
			$_SESSION['continue'] = false;
		}

		clearstatcache();
	}
	else
	{
		echo "<font color=\"red\">config.inc.php not found in root directory!</font>";
		$_SESSION['continue'] = false;
	}

	clearstatcache();
	?>
	</td>
</tr>
<tr>
	<td>Path to config.inc.php:</td>
	<td>
	<?php 
	if (file_exists('../config.inc.php'))
	{
		$path = str_replace("install", "", dirname($_SERVER['SCRIPT_FILENAME']));
		echo "<font color=\"green\">".$path."config.inc.php</font>";
		$_SESSION['config'] = "".$path."config.inc.php";
	}
	else
	{
		echo "<font color=\"red\">config.inc.php not found in root directory!</font>";
		$_SESSION['continue'] = false;
	}

	clearstatcache();
	?>
	</td>
</tr>
<tr>
	<td>Relata Installation URL:</td>
	<td>
	<?php 
	if (file_exists('../config.inc.php'))
	{
		$path = str_replace("install", "", dirname($_SERVER['REQUEST_URI']));
		$protocol = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") ? "https" : "http";
		echo "<font color=\"green\">".$protocol."://".$_SERVER['HTTP_HOST'].$path."</font>";
		$_SESSION['relataurl'] = $protocol."://".$_SERVER['HTTP_HOST'].$path;
	}
	else
	{
		echo "<font color=\"red\">config.inc.php not found in root directory!</font>";
		$_SESSION['continue'] = false;
	}

	clearstatcache();
	?>
	</td>
</tr>
<tr>
	<td>'upload' directory writable:</td>
	<td>
	<?php
	$path = ($_SESSION['os'] == "win") ? str_replace("install", "upload/", dirname($_SERVER['SCRIPT_FILENAME'])) : str_replace("install/", "upload/", dirname($_SERVER['SCRIPT_FILENAME']));
	if (file_exists($path))
	{
		if (is_writable($path))
		{
			echo "<font color=\"green\">Yes</font> (Required by Relata File Manager)";
			$_SESSION['uploadpath'] = $path;
			clearstatcache();
		}
		else
			echo "<font color=\"red\">No</font> -- Check web permissions. Current permissions: ".substr(sprintf('%o', fileperms($path)), -4);
	}
	else if (get_cfg_var('safe_mode') && $_SESSION['os'] != "win")
	{
			$dirowner = posix_getpwuid(fileowner($path));
			$fileowner = posix_getpwuid(fileowner($_SERVER['SCRIPT_FILENAME']));
			echo "<font color=\"red\">'upload' directory does not exist or is not accessible. Directory owner (".$dirowner['name'].") != current file owner (".$fileowner['name'].")</font>";
	}
	else
		echo "<font color=\"red\">'upload' directory doesn't exist.</font>";

	clearstatcache();
	?>
	</td>
</tr>
</table>
<form action="installhelper2.php">
<?php
if (!$_SESSION['continue'])
	$DISABLED = "DISABLED";
?>
	<input type="Submit" value="Continue" <?php echo $DISABLED; ?>>
</form>
Ensure anything in <font color="red">red</font> is corrected before continuing.<br />
Refresh this page to check any changes you make to <?php echo basename($_SESSION['phppath']); ?>.
</div>
</body>
</html>